<template>
  <q-layout view="hHh lpR fFf" role="region" aria-label="XBRL Taxonomy viewer">
    <!-- Header -->
    <AppHeader :dts_name="dts_name" :dts_nice_name="dts_nice_name" :nt_version="nt_version"></AppHeader>

    <!-- Zoekbalk -->
    <q-toolbar class="search-pane detail_bg q-pb-md q-pt-sm fixed" role="region" aria-label="Zoeken">
      <div class="row q-ma-sm">
        <q-input label="Zoek"
                 v-model="search_value"
                 class="q-pr-md bg-white shadow-1 input__search"
                 autofocus
                 clearable
                 size="60"
                 @keyup.enter="fetchdata">
          <template v-slot:prepend>
            <q-icon name="search"/>
          </template>
        </q-input>

        <q-select
          v-model="selected_role"
          :options="roles"
          class="q-mr-md q-pl-sm role_selector bg-white shadow-1"
          label="filter op rol"></q-select>
        <q-select
          v-model="selected_language"
          :options="languages"
          class="language_selector q-pl-sm bg-white shadow-1"
          label="filter op taal">
        </q-select>
      </div>
    </q-toolbar>

    <!-- Resultaten / Detail -->
    <div class="row">
      <div class="results-listview" role="region" aria-label="Zoekresultaten">
        <LabelList :dts_name="dts_name"
                   :nt_version="nt_version"
                   :labels="labels"
                   :loading="loading"
                   :filter_lang="selected_language"
                   :filter_role="selected_role"
                   :search_value="search_value"></LabelList>
      </div>
      <div class="results-listview__padding" role="region" aria-label="Details">
        <router-view/>
      </div>
    </div>

    <!-- Footer -->
    <q-footer bordered class="bg-primary text-white">
      <q-toolbar role="presentation">
        <q-toolbar-title class="absolute-bottom-left q-mr-md q-mb-sm footer full-width row">
          <div class="col-9 entrypoint-chooser-wrapper">
            <EntrypointChooser :current_dts_name="dts_name" :current_nt_version="nt_version"></EntrypointChooser>
          </div>
          <div class="col-2">
          </div>
          <div class="footer__help q-pl-md cursor-pointer col-1">
            <q-icon size="lg" name="help_outline"
                    @click="open_help()"></q-icon>
          </div>
        </q-toolbar-title>
      </q-toolbar>
    </q-footer>

  </q-layout>
</template>

<script>
/*
 * This is somewhat different from teh rest.
 */
import {api} from 'boot/axios'
import LabelList from "components/LabelList";
import _ from "lodash"
import Help from "layouts/Help";
import AppHeader from "components/AppHeader";
import EntrypointChooser from "components/EntrypointChooser";

export default {
  name: "LabelViewer.vue",
  components: {AppHeader, EntrypointChooser, LabelList},
  mounted() {
    this.get_dts_nice_name()
    this.get_languages()
    this.get_label_roles()
    this.fetchdata()
    document.title = "Zoeken naar labels - XBRL Taxonomy viewwer"
  },
  props: {
    dts_name: String,
    nt_version: String,
  },
  data: function () {
    return {
      dts_nice_name: null,
      search_value: null,
      languages: ['Alle'],
      roles: ['Alle'],
      selected_role: 'Alle',
      selected_language: 'Alle',
      labels: undefined,
      loading: false,
      hide_help: "hidden"
    }
  },
  methods: {
    fetchdata: function () {
      this.loading = true
      let url = "/dts/" + this.dts_name + "/labels"
      let params = {nt_version: this.nt_version, q: undefined}
      api
        .get(url, {params: params})
        .then(response => {
          this.labels = response.data
          if (this.labels.length && this.$route.fullPath.endsWith('labels')) {
            this.$router.push({
              name: 'label_detail',
              params: {
                label_id: this.labels[0].id,
                label_text: this.labels[0].label_text,
                link_role: this.labels[0].link_role,
                label_lang: this.labels[0].lang,
              }
            })
          }
          this.loading = false
        })
        .catch((error) => {
          this.labels = []
          this.loading = false
          console.log(error)
        })

    },
    get_dts_nice_name: function () {
      api
        .get("/dts/" + this.dts_name + "/nice_name", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.dts_nice_name = response.data.dts_nice_name
        })
        .catch((error) => {
          this.dts_nice_name = "[**entrypoint not found**]"
        })
    },
    get_languages: function () {
      api.get('/dts/' + this.dts_name + '/languages', {params: {nt_version: this.nt_version}})
        .then(response => {
          this.languages = _.union(this.languages, response.data)
        })
        .catch((error) => {
          this.languages = []
        })

    },
    open_help: function () {
      window.open('/docs/vw-labels/', 'help-window', 'width=980, height=1020')
    },
    get_label_roles: function () {
      api.get("/label_roles", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.roles = _.union(this.roles, response.data)
        })
        .catch((error) => {
          this.roles = []
        })

    }
  }

}
</script>

<style scoped lang="scss">
.appname {
  color: $blue-2;
}

.language_selector {
  width: 200px;
}

.role_selector {
  min-width: 300px;
}

.input__search {
  margin-right: 40px;
}

.search-pane {
  top: 100px;
  z-index: 10;
}

.results-listview {
  position: fixed;
  top: 199px;
  width: 40%;
  overflow-x: auto;
  overflow-y: auto;
}

.results-listview__padding {
  padding-left: 40%;
  padding-top: 200px;
  width: 100%;
}
</style>
